; VBI.ASM
; version       1.04
;
; by Yzi/Fit
;
; first version: 31.05.1996
; last modified: 20.05.1997
;
; version info:
;
; ----------- 1.04 ------------------------------------------------------
; 20.05.1997: +  Check for vbiSyncError, (Win95 or something)
;             +  added pushf/cli/popf to vbiMeasure
;
; ----------- 1.03 ------------------------------------------------------
; 14.10.1996: +  The measured frame rate can be calculated from
;                vbiRealTicks, which also includes the OVERHEAD.
;
; ----------- 1.02 ------------------------------------------------------
; 22.07.1996: +  The time between vblanks can be measured with vbiMeasure
;             +  vbiDataSeg now in .code
;
; ----------- 1.01 ------------------------------------------------------
; 09.07.1996: +  Added support for non-double functionality
;             +  Now preserves correct time!
;


.386
.model flat, prolog
locals

OVERHEAD        equ     400     ; tmn verran otetaan pois koko framesta

public  _vbiTicks1
public  _vbiTicks2
public  _vbiTicks
public  _vbiRealTicks
public  _vbiSyncOn
public  _vbiDoubleOn
public  _vbiSyncError
public   vbiMeasure_
public   vbiInit_
public   vbiClose_

.data
        vbiOldTimer     df 0
        vbiToggle       dd 0
        vbiProc0        dd 0
        vbiProc1        dd 0
        vbiProc2        dd 0
        kesken          dd 0
        _vbiTicks1      dw 12150
        _vbiTicks2      dw 4200
        _vbiTicks       dw 16650   ; koko frame noin 17000
        _vbiRealTicks   dw 17000   ; koko framen aika
        _vbiSyncOn      dw 1       ; tahdistetaanko?
        _vbiDoubleOn    dw 1
        _vbiSyncError   dw 0       ; Win95 tai muu tuhoaa ajoituksen

.code

        vbiDataSeg      dd 0


ReadTime macro RegHi, RegLo
        sub     al, al          ;latch count = 0
        out     43h, al
        in      al, 40h
        mov     RegLo, al
        in      al, 40h
        mov     RegHi, al          ;65536-clicks
endm

; 
;  vbiTimerHandler
;
;  This is the actual handler called by IRQ 0.
; 

vbiTimerHandler proc
        pushad
        push    ds
        mov     ds,cs:vbiDataSeg
        test    ds:_vbiDoubleOn, 1
        jz      @@nodbl
        test    ds:vbiToggle, 1
        jnz     @@toka
@@nodbl:call    ds:vbiProc0

        test    ds:_vbiSyncOn, 1
        jz      @@nosync

        ReadTime ch, cl

        mov     dx, 3DAh
@@wretr:in      al, dx
        test    al, 8
        jz      @@wretr
@@nosync:

        ReadTime dh, dl

        sub     cx, dx
        cmp     cx, 5000
        jb      @@noerror
        mov     _vbiSyncError, 1
@@noerror:

        mov     al, 34h
        out     43h, al
        test    ds:_vbiDoubleOn, 1
        jz      @@otsa
        mov     ax, ds:_vbiTicks1
        jmp     @@ohimo
@@otsa: mov     ax, ds:_vbiTicks
@@ohimo:out     40h, al
        mov     al, ah
        out     40h, al
        mov     al, 20h
        out     20h, al
        call    ds:vbiProc1

        mov     ds:vbiToggle, 1

        jmp     @@ohi
@@toka:
        mov     al, 34h
        out     43h, al
        mov     ax, ds:_vbiTicks2
        out     40h, al
        mov     al, ah
        out     40h, al

        mov     al, 20h
        out     20h, al

        call    ds:vbiProc2

        mov     ds:vbiToggle, 0
@@ohi:
        pop     ds
        popad
        iret
vbiTimerHandler endp


; 
;  void vbiMeasure (void)
;
;  Measures the time between two vertical retraces.
; 

vbiMeasure_     proc

        pushf
        cli

        mov     al, 34h         ;Start timer
        out     43h, al
	sub     al, al
        out     40h, al
        out     40h, al

        mov     dx, 3dah

@@vr1:  in      al, dx          ;wait for non-retrace
        test    al, 8
        jnz     @@vr1
@@vb1:  in      al, dx          ;wait for retrace
        test    al, 8
        jz      @@vb1

        ReadTime ch, cl

@@vr2:  in      al, dx
        test    al, 8
        jnz     @@vr2
@@vb2:  in      al, dx          ;get another vblank start
        test    al, 8
        jz      @@vb2

        ReadTime dh, dl

        sub     cx, dx          ;cx=clicks between two vsyncs
        mov     _vbiRealTicks, cx
        sub     cx, OVERHEAD
        mov     _vbiTicks, cx
        sub     cx, _vbiTicks2
        mov     _vbiTicks1, cx

        popf

        ret
vbiMeasure_     endp


; 
;  void vbiInit(void *vbiProc0, void *vbiProc1, void *vbiProc2)
;
;  Sets IRQ 0 vector (int 8) and programs PIT.
;
;  EBX->vbiProc0
;  ESI->vbiProc1
;  EDI->vbiProc2
; 
vbiInit_ proc
        mov     vbiDataSeg, ds
        mov     vbiToggle, 0

        mov     vbiProc0, ebx
        mov     vbiProc1, esi
        mov     vbiProc2, edi

        push    es
        mov     ax, 3508h
        int     21h
        mov     dword ptr vbiOldTimer+0, ebx
        mov     word ptr vbiOldTimer+4, es
        pop     es

        push    ds
        mov     ax, 2508h
        push    cs
        pop     ds
        mov     edx, offset vbiTimerHandler
        int     21h
        pop     ds

        mov     dx, 3DAh
@@wtvb: in      al, dx
        test    al, 8
        jz      @@wtvb

        mov     al, 34h
        out     43h, al
        test    _vbiDoubleOn, 1
        jz      @koira
        mov     ax, _vbiTicks1
        jmp     @kissa
@koira: mov     ax, _vbiTicks
@kissa: out     40h ,al
        mov     al, ah
        out     40h, al
        ret
vbiInit_        endp


; 
;  void vbiClose (void)
;
;  Restores IRQ 0 vector (int 8), sets PIT rate to 18.2 Hz and
;  restores the correct time from Real Time Clock.
;
; 
vbiClose_ proc
        push    ds
        mov     ax, 2508h
        lds     edx, vbiOldTimer
        int     21h
        mov     al, 34h
        out     43h, al
        xor     ax, ax
        out     40h ,al
        mov     al, ah
        out     40h, al

        mov     ah, 2           ;get correct time from RTC
        int     1Ah             ;int 1a, 2
        sub     ah, ah          ;returns time as ch:cl:dh BCD
        mov     bl, 10          ;the BCD numbers have to be
        mov     al, ch          ;converted before passing to
        shr     al, 4           ;the dos service
        mul     bl
        and     ch, 0Fh
        add     al, ch
        mov     ch, al
        mov     al, cl
        shr     al, 4
        mul     bl
        and     cl, 0Fh
        add     al, cl
        mov     cl, al
        mov     al, dh
        shr     al, 4
        mul     bl
        and     dh, 0Fh
        add     al, dh
        mov     dh, al
        sub     dl, dl
        mov     ah, 2Dh         ;int 21, 2d: set time (ch:cl:dh:dl)
        int     21h

        pop     ds
        ret
vbiClose_       endp

end
