/*
  Use Watcom C
*/

// #define DOSBOX_LAMER

#include <stdio.h>
#include <conio.h>
#include "vbi.h"

#define PIT_CLOCK_FREQUENCY (1193182)

#pragma aux setmode=    "int    010h"\
                        parm [eax];

// Note: these have to be volatile, or otherwise Watcom will optimize the
//       wait_for_VBI() routine into an endless loop.
volatile int vbi_framecount=0, vbi_prev_framecount=0;

// callbacks
volatile void vbi0 (void) { int i=0; i++; }
volatile void vbi1 (void) { vbi_framecount ++; }
volatile void vbi2 (void) { int i=0; i++; }


void wait_for_VBI()
{
        // wait for vbi to happen
        while (vbi_framecount == vbi_prev_framecount) {}
        vbi_prev_framecount = vbi_framecount;
}


void main (void)
{
        setmode(0x13);

        // Double interrupts can be used if you want to e.g. start GUS volume envelopes
        // slightly before the main playroutine is called, to prevent UltraClicks.
        vbiDoubleOn = 0;

#ifdef DOSBOX_LAMER
        vbiSyncOn = 0; // turn off syncing to port $3DA vertical retrace bit

        vbiRealTicks = 19906; // hard-code the timer interrupta to about 60 Hz
        vbiTicks = vbiRealTicks - (vbiSyncOn?400:0);
        printf("vbiTicks %d\n", vbiTicks);
        vbiTicks2 = 4500;
        vbiTicks1 = vbiTicks - vbiTicks2;
#else
        vbiMeasure (); // <-- measure the time between vertical retraces

        // Note: IF you have vbiSyncOn==1, then Dosbox might actually slow your frame
        //       rate to the host display, usually 60 fps, EVEN THOUGH at the same time
        //       the vbiMeasure() routine has measured the rate to be 70 fps!?
        //       At least in my own tests as of writing this, 2016-02-19, Dosbox 0.74 in Debian/x86.
        //
        //       In order to liberate your code from Dosbox craziness, you have to turn vsyncing OFF
        //       in your DOS program, and only sync to a timer interrupt.
#endif



        vbiInit (&vbi0, &vbi1, &vbi2);

        while (!kbhit())
        {
                wait_for_VBI();

                // do your demo effect here

        } // while (!kbhit())

        vbiClose ();

        setmode (3);
        printf ("no niin\n");

#ifdef DOSBOX_LAMER
        printf ("Interrupt rate was: ");
#else
        printf ("Measured frame duration: ");
#endif
	printf ("%d PIT ticks, appr. %f frames/second\n",
                vbiRealTicks, (double)(PIT_CLOCK_FREQUENCY) / (double)(vbiRealTicks)
        );

} // main


